//
//  SectionAppDelegate.m
//  Section
//
//  Created by Laurence Ehrhardt on 7/26/11.
//  Copyright 2011 Ballast Lane Applications. All rights reserved.
//

#import "SectionAppDelegate.h"
#import "SectionViewController.h"
#import "XMLParser.h"
#import "Person.h"

@implementation SectionAppDelegate

@synthesize persons=_persons;

@synthesize window=_window;

@synthesize viewController=_viewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    
    //Read in xml
    
    self.persons = [[NSMutableArray alloc] initWithObjects:nil];
    
    NSString    * xmlPath   = [[NSBundle mainBundle] pathForResource:@"Persons" ofType:@"xml"];
    NSData      * xmlFile   = [[NSData alloc] initWithContentsOfFile:xmlPath];
    NSXMLParser * xmlParser = [[NSXMLParser alloc] initWithData:xmlFile];
    
	//Initialize the delegate.
	XMLParser * parser = [[XMLParser alloc] initXMLParser];
	
	//Set delegate
	[xmlParser setDelegate:parser];
	
	//Start parsing the XML file.
	BOOL success = [xmlParser parse];
	
	if(success)
		NSLog(@"No Errors");
	else
		NSLog(@"Error Error Error!!!");	
    
    [parser release];
    [xmlFile release];
    [xmlParser release];
    
    //Launch main window
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

- (void)dealloc
{   
    [_persons release];
    [_window release];
    [_viewController release];
    [super dealloc];
}

@end
