//
//  SectionViewController.h
//  Section
//
//  Created by Laurence Ehrhardt on 7/26/11.
//  Copyright 2011 Ballast Lane Applications. All rights reserved.
//
//  This is the main view controller file used to drive the functionality 
//  of the SectionView nib file.  


#import <UIKit/UIKit.h>
#import "SectionAppDelegate.h"


// in the interface declaration you include the name of the class, it's associated view type and any
// delegates that you are using

//UIViewController is the superclass
//<These are the delegate classes>

@interface SectionViewController : UIViewController <UIAlertViewDelegate> {
    
    SectionAppDelegate * appDelegate;

}

//Class (instance) variables

//View related variables
//IB Outlets - don't forget to hook these up in the xib file!
@property (nonatomic, retain) IBOutlet UITextField * myField;
@property (nonatomic, retain) IBOutlet UILabel * myLabel;

//Variables (Strings, Arrays etc.)
@property (nonatomic, retain) NSString * myName;
@property (nonatomic, retain) NSArray * startingNames;
@property (nonatomic, retain) NSMutableArray * theNewNames;


//Class (instance) methods

// basic method (return type) name;
- (void) setStart;

// method with an argument
- (int) checkName: (NSString *) nameToCheck;

// method called by an IB Action - don't forget to hook these up in the nib file!
- (IBAction) buttonPressed: (id) sender;

@end
