//
//  SectionViewController.m
//  Section
//
//  Created by Laurence Ehrhardt on 7/26/11.
//  Copyright 2011 Ballast Lane Applications. All rights reserved.
//
//  This is the implementation file for the SectionViewController

//import the header file and any other class whose methods you are going to access
#import "SectionViewController.h"
#import "SectionAppDelegate.h"
#import "Person.h"

@implementation SectionViewController

// implements variable handling code

@synthesize myField = _myField, myName = _myName, myLabel = _myLabel, startingNames = _startingNames, theNewNames = _theNewNames;

// implementation of my custom methods

- (void) setStart {
    
    //initialize values into some of the class variables - in this case an array, mutable array and a IB element
    
    //get persons from the appdelegate
    appDelegate = (SectionAppDelegate *) [[UIApplication sharedApplication] delegate];
    self.startingNames = [[NSArray alloc] initWithArray:appDelegate.persons];
    
    //initialize MutableArray
    self.theNewNames = [[NSMutableArray alloc] init];
    
    //Send some text to an IB Element ("an outlet")
    self.myLabel.text = @"Waiting for Input";
    
    
    // Example method scoped variable.  Need to uncomment last line to avoid leak
    NSArray * test = [[NSArray alloc] initWithObjects:@"test", nil];
                      
    NSLog(@"Length of test %i", [test count]);
        
    //[test release];
    
}


// example of method returning an int
- (int) checkName:(NSString *)nameToCheck {
    
    NSLog (@"Input %@", nameToCheck);
    
    int a = 1;
    
    NSLog(@"Count in startingNames %i", self.startingNames.count);
    
    for (Person *person in self.startingNames) {
        
       if ([[person.firstName stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] isEqualToString:nameToCheck]) {
           a = 0;
           NSLog (@"Checking %@", person.firstName);
        }
    }
    
    return a;
}

//example of a method executed based on a user action

- (IBAction) buttonPressed: (id) sender {
    
    if (self.myField.text.length < 1) {
        
        //You need to establish this class as a delegate to UIAlertView for this to work
        //Check out the .h file to see how this is done
        
        UIAlertView *av = [[[UIAlertView alloc] initWithTitle:@"Validation"
                                                      message:@"Please Input an Input"
                                                     delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil] autorelease];
        [av show];
    
    } else {    
        
        int b = 0;
        
        b = [self checkName:self.myField.text];
        
        NSLog (@"Answer %i", b);
        
        if (b == 0) {
            self.myLabel.text = @"Already Known";
        } else {
            [self.theNewNames addObject:self.myField.text]; 
            self.myLabel.text = @"Added to New Names Array";
            NSLog (@"New Names Array is now %i long", [self.theNewNames count]);
        }
    }
}


// release your class level variables here - do it before you call [super dealloc]
// test you memory management with Profiler (Leaks)

- (void)dealloc
{
    [_myField release];
    [_myName release];
    [_myLabel release];
    [_startingNames release];
    [_theNewNames release];
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // used to call a start up method in this case
    
    [self setStart];

}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return YES;
}

@end
