//
//  XMLParser.m
//  XML
//
//  Created by iPhone SDK Articles on 11/23/08.
//  Copyright 2008 www.iPhoneSDKArticles.com.
//

#import "XMLParser.h"
#import "SectionAppDelegate.h"
#import "Person.h"

@implementation XMLParser

- (XMLParser *) initXMLParser {
	
	[super init];
	
	appDelegate = (SectionAppDelegate *)[[UIApplication sharedApplication] delegate];
	
	return self;
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName 
	attributes:(NSDictionary *)attributeDict {
	
	if([elementName isEqualToString:@"persons"]) {

        }
        else if([elementName isEqualToString:@"person"]) {
		aPerson = [[Person alloc] init];
        }
	
	NSLog(@"Processing Element: %@", elementName);
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string { 
	
	if(!currentElementValue) {
		currentElementValue = [[NSMutableString alloc] initWithString:string];

    }
	else {
		[currentElementValue appendString:string];
        
        //NSLog(@"Processing Value: %@", [currentElementValue stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]);
    }
	
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	
	if([elementName isEqualToString:@"persons"])
		return;
	
	if([elementName isEqualToString:@"person"]) {
        [appDelegate.persons addObject:aPerson];
		[aPerson release];
		aPerson = nil;
	}
	else 
		[aPerson setValue:currentElementValue forKey:elementName];
	
	[currentElementValue release];
	currentElementValue = nil;
}

- (void) dealloc {
	[aPerson release];
	[currentElementValue release];
	[super dealloc];
}

@end
